import * as f from "react";
import { useLayoutEffect as tt, useEffect as nt } from "react";
import * as rt from "react-dom";
function ot(e) {
  var t, r, n = "";
  if (typeof e == "string" || typeof e == "number") n += e;
  else if (typeof e == "object") if (Array.isArray(e)) {
    var o = e.length;
    for (t = 0; t < o; t++) e[t] && (r = ot(e[t])) && (n && (n += " "), n += r);
  } else for (r in e) e[r] && (n && (n += " "), n += r);
  return n;
}
function qn() {
  for (var e, t, r = 0, n = "", o = arguments.length; r < o; r++) (e = arguments[r]) && (t = ot(e)) && (n && (n += " "), n += t);
  return n;
}
function ge() {
  return typeof window < "u";
}
function Q(e) {
  return it(e) ? (e.nodeName || "").toLowerCase() : "#document";
}
function N(e) {
  var t;
  return (e == null || (t = e.ownerDocument) == null ? void 0 : t.defaultView) || window;
}
function K(e) {
  var t;
  return (t = (it(e) ? e.ownerDocument : e.document) || window.document) == null ? void 0 : t.documentElement;
}
function it(e) {
  return ge() ? e instanceof Node || e instanceof N(e).Node : !1;
}
function T(e) {
  return ge() ? e instanceof Element || e instanceof N(e).Element : !1;
}
function k(e) {
  return ge() ? e instanceof HTMLElement || e instanceof N(e).HTMLElement : !1;
}
function Re(e) {
  return !ge() || typeof ShadowRoot > "u" ? !1 : e instanceof ShadowRoot || e instanceof N(e).ShadowRoot;
}
function ie(e) {
  const {
    overflow: t,
    overflowX: r,
    overflowY: n,
    display: o
  } = B(e);
  return /auto|scroll|overlay|hidden|clip/.test(t + n + r) && !["inline", "contents"].includes(o);
}
function Dt(e) {
  return ["table", "td", "th"].includes(Q(e));
}
function he(e) {
  return [":popover-open", ":modal"].some((t) => {
    try {
      return e.matches(t);
    } catch {
      return !1;
    }
  });
}
function Ie(e) {
  const t = Ae(), r = T(e) ? B(e) : e;
  return r.transform !== "none" || r.perspective !== "none" || (r.containerType ? r.containerType !== "normal" : !1) || !t && (r.backdropFilter ? r.backdropFilter !== "none" : !1) || !t && (r.filter ? r.filter !== "none" : !1) || ["transform", "perspective", "filter"].some((n) => (r.willChange || "").includes(n)) || ["paint", "layout", "strict", "content"].some((n) => (r.contain || "").includes(n));
}
function Pt(e) {
  let t = H(e);
  for (; k(t) && !X(t); ) {
    if (Ie(t))
      return t;
    if (he(t))
      return null;
    t = H(t);
  }
  return null;
}
function Ae() {
  return typeof CSS > "u" || !CSS.supports ? !1 : CSS.supports("-webkit-backdrop-filter", "none");
}
function X(e) {
  return ["html", "body", "#document"].includes(Q(e));
}
function B(e) {
  return N(e).getComputedStyle(e);
}
function pe(e) {
  return T(e) ? {
    scrollLeft: e.scrollLeft,
    scrollTop: e.scrollTop
  } : {
    scrollLeft: e.scrollX,
    scrollTop: e.scrollY
  };
}
function H(e) {
  if (Q(e) === "html")
    return e;
  const t = (
    // Step into the shadow DOM of the parent of a slotted node.
    e.assignedSlot || // DOM Element detected.
    e.parentNode || // ShadowRoot detected.
    Re(e) && e.host || // Fallback.
    K(e)
  );
  return Re(t) ? t.host : t;
}
function st(e) {
  const t = H(e);
  return X(t) ? e.ownerDocument ? e.ownerDocument.body : e.body : k(t) && ie(t) ? t : st(t);
}
function Z(e, t, r) {
  var n;
  t === void 0 && (t = []), r === void 0 && (r = !0);
  const o = st(e), s = o === ((n = e.ownerDocument) == null ? void 0 : n.body), i = N(o);
  if (s) {
    const c = Ee(i);
    return t.concat(i, i.visualViewport || [], ie(o) ? o : [], c && r ? Z(c) : []);
  }
  return t.concat(o, Z(o, [], r));
}
function Ee(e) {
  return e.parent && Object.getPrototypeOf(e.parent) ? e.frameElement : null;
}
function It(e) {
  let t = e.activeElement;
  for (; ((r = t) == null || (r = r.shadowRoot) == null ? void 0 : r.activeElement) != null; ) {
    var r;
    t = t.shadowRoot.activeElement;
  }
  return t;
}
function Ce(e, t) {
  if (!e || !t)
    return !1;
  const r = t.getRootNode == null ? void 0 : t.getRootNode();
  if (e.contains(t))
    return !0;
  if (r && Re(r)) {
    let n = t;
    for (; n; ) {
      if (e === n)
        return !0;
      n = n.parentNode || n.host;
    }
  }
  return !1;
}
function At() {
  return /apple/i.test(navigator.vendor);
}
function Be(e, t) {
  return ["mouse", "pen"].includes(e);
}
function Nt(e) {
  return "nativeEvent" in e;
}
function kt(e) {
  return e.matches("html,body");
}
function Se(e) {
  return (e == null ? void 0 : e.ownerDocument) || document;
}
function me(e, t) {
  if (t == null)
    return !1;
  if ("composedPath" in e)
    return e.composedPath().includes(t);
  const r = e;
  return r.target != null && t.contains(r.target);
}
function ne(e) {
  return "composedPath" in e ? e.composedPath()[0] : e.target;
}
const Mt = "input:not([type='hidden']):not([disabled]),[contenteditable]:not([contenteditable='false']),textarea:not([disabled])";
function Lt(e) {
  return k(e) && e.matches(Mt);
}
const ce = Math.min, $ = Math.max, le = Math.round, q = (e) => ({
  x: e,
  y: e
});
function ct(e, t) {
  return typeof e == "function" ? e(t) : e;
}
function Ne(e) {
  return e.split("-")[0];
}
function lt(e) {
  return e.split("-")[1];
}
function Ft(e) {
  return e === "x" ? "y" : "x";
}
function Bt(e) {
  return e === "y" ? "height" : "width";
}
function ke(e) {
  return ["top", "bottom"].includes(Ne(e)) ? "y" : "x";
}
function Wt(e) {
  return Ft(ke(e));
}
function $t(e) {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0,
    ...e
  };
}
function _t(e) {
  return typeof e != "number" ? $t(e) : {
    top: e,
    right: e,
    bottom: e,
    left: e
  };
}
function ae(e) {
  const {
    x: t,
    y: r,
    width: n,
    height: o
  } = e;
  return {
    width: n,
    height: o,
    top: r,
    left: t,
    right: t + n,
    bottom: r + o,
    x: t,
    y: r
  };
}
/*!
* tabbable 6.2.0
* @license MIT, https://github.com/focus-trap/tabbable/blob/master/LICENSE
*/
var Vt = ["input:not([inert])", "select:not([inert])", "textarea:not([inert])", "a[href]:not([inert])", "button:not([inert])", "[tabindex]:not(slot):not([inert])", "audio[controls]:not([inert])", "video[controls]:not([inert])", '[contenteditable]:not([contenteditable="false"]):not([inert])', "details>summary:first-of-type:not([inert])", "details:not([inert])"], Te = /* @__PURE__ */ Vt.join(","), at = typeof Element > "u", re = at ? function() {
} : Element.prototype.matches || Element.prototype.msMatchesSelector || Element.prototype.webkitMatchesSelector, ue = !at && Element.prototype.getRootNode ? function(e) {
  var t;
  return e == null || (t = e.getRootNode) === null || t === void 0 ? void 0 : t.call(e);
} : function(e) {
  return e == null ? void 0 : e.ownerDocument;
}, fe = function e(t, r) {
  var n;
  r === void 0 && (r = !0);
  var o = t == null || (n = t.getAttribute) === null || n === void 0 ? void 0 : n.call(t, "inert"), s = o === "" || o === "true", i = s || r && t && e(t.parentNode);
  return i;
}, Ht = function(t) {
  var r, n = t == null || (r = t.getAttribute) === null || r === void 0 ? void 0 : r.call(t, "contenteditable");
  return n === "" || n === "true";
}, Kt = function(t, r, n) {
  if (fe(t))
    return [];
  var o = Array.prototype.slice.apply(t.querySelectorAll(Te));
  return r && re.call(t, Te) && o.unshift(t), o = o.filter(n), o;
}, jt = function e(t, r, n) {
  for (var o = [], s = Array.from(t); s.length; ) {
    var i = s.shift();
    if (!fe(i, !1))
      if (i.tagName === "SLOT") {
        var c = i.assignedElements(), a = c.length ? c : i.children, l = e(a, !0, n);
        n.flatten ? o.push.apply(o, l) : o.push({
          scopeParent: i,
          candidates: l
        });
      } else {
        var u = re.call(i, Te);
        u && n.filter(i) && (r || !t.includes(i)) && o.push(i);
        var d = i.shadowRoot || // check for an undisclosed shadow
        typeof n.getShadowRoot == "function" && n.getShadowRoot(i), m = !fe(d, !1) && (!n.shadowRootFilter || n.shadowRootFilter(i));
        if (d && m) {
          var g = e(d === !0 ? i.children : d.children, !0, n);
          n.flatten ? o.push.apply(o, g) : o.push({
            scopeParent: i,
            candidates: g
          });
        } else
          s.unshift.apply(s, i.children);
      }
  }
  return o;
}, ut = function(t) {
  return !isNaN(parseInt(t.getAttribute("tabindex"), 10));
}, ft = function(t) {
  if (!t)
    throw new Error("No node provided");
  return t.tabIndex < 0 && (/^(AUDIO|VIDEO|DETAILS)$/.test(t.tagName) || Ht(t)) && !ut(t) ? 0 : t.tabIndex;
}, Yt = function(t, r) {
  var n = ft(t);
  return n < 0 && r && !ut(t) ? 0 : n;
}, Ut = function(t, r) {
  return t.tabIndex === r.tabIndex ? t.documentOrder - r.documentOrder : t.tabIndex - r.tabIndex;
}, dt = function(t) {
  return t.tagName === "INPUT";
}, Xt = function(t) {
  return dt(t) && t.type === "hidden";
}, qt = function(t) {
  var r = t.tagName === "DETAILS" && Array.prototype.slice.apply(t.children).some(function(n) {
    return n.tagName === "SUMMARY";
  });
  return r;
}, Gt = function(t, r) {
  for (var n = 0; n < t.length; n++)
    if (t[n].checked && t[n].form === r)
      return t[n];
}, zt = function(t) {
  if (!t.name)
    return !0;
  var r = t.form || ue(t), n = function(c) {
    return r.querySelectorAll('input[type="radio"][name="' + c + '"]');
  }, o;
  if (typeof window < "u" && typeof window.CSS < "u" && typeof window.CSS.escape == "function")
    o = n(window.CSS.escape(t.name));
  else
    try {
      o = n(t.name);
    } catch (i) {
      return console.error("Looks like you have a radio button with a name attribute containing invalid CSS selector characters and need the CSS.escape polyfill: %s", i.message), !1;
    }
  var s = Gt(o, t.form);
  return !s || s === t;
}, Zt = function(t) {
  return dt(t) && t.type === "radio";
}, Jt = function(t) {
  return Zt(t) && !zt(t);
}, Qt = function(t) {
  var r, n = t && ue(t), o = (r = n) === null || r === void 0 ? void 0 : r.host, s = !1;
  if (n && n !== t) {
    var i, c, a;
    for (s = !!((i = o) !== null && i !== void 0 && (c = i.ownerDocument) !== null && c !== void 0 && c.contains(o) || t != null && (a = t.ownerDocument) !== null && a !== void 0 && a.contains(t)); !s && o; ) {
      var l, u, d;
      n = ue(o), o = (l = n) === null || l === void 0 ? void 0 : l.host, s = !!((u = o) !== null && u !== void 0 && (d = u.ownerDocument) !== null && d !== void 0 && d.contains(o));
    }
  }
  return s;
}, We = function(t) {
  var r = t.getBoundingClientRect(), n = r.width, o = r.height;
  return n === 0 && o === 0;
}, en = function(t, r) {
  var n = r.displayCheck, o = r.getShadowRoot;
  if (getComputedStyle(t).visibility === "hidden")
    return !0;
  var s = re.call(t, "details>summary:first-of-type"), i = s ? t.parentElement : t;
  if (re.call(i, "details:not([open]) *"))
    return !0;
  if (!n || n === "full" || n === "legacy-full") {
    if (typeof o == "function") {
      for (var c = t; t; ) {
        var a = t.parentElement, l = ue(t);
        if (a && !a.shadowRoot && o(a) === !0)
          return We(t);
        t.assignedSlot ? t = t.assignedSlot : !a && l !== t.ownerDocument ? t = l.host : t = a;
      }
      t = c;
    }
    if (Qt(t))
      return !t.getClientRects().length;
    if (n !== "legacy-full")
      return !0;
  } else if (n === "non-zero-area")
    return We(t);
  return !1;
}, tn = function(t) {
  if (/^(INPUT|BUTTON|SELECT|TEXTAREA)$/.test(t.tagName))
    for (var r = t.parentElement; r; ) {
      if (r.tagName === "FIELDSET" && r.disabled) {
        for (var n = 0; n < r.children.length; n++) {
          var o = r.children.item(n);
          if (o.tagName === "LEGEND")
            return re.call(r, "fieldset[disabled] *") ? !0 : !o.contains(t);
        }
        return !0;
      }
      r = r.parentElement;
    }
  return !1;
}, nn = function(t, r) {
  return !(r.disabled || // we must do an inert look up to filter out any elements inside an inert ancestor
  //  because we're limited in the type of selectors we can use in JSDom (see related
  //  note related to `candidateSelectors`)
  fe(r) || Xt(r) || en(r, t) || // For a details element with a summary, the summary element gets the focus
  qt(r) || tn(r));
}, $e = function(t, r) {
  return !(Jt(r) || ft(r) < 0 || !nn(t, r));
}, rn = function(t) {
  var r = parseInt(t.getAttribute("tabindex"), 10);
  return !!(isNaN(r) || r >= 0);
}, on = function e(t) {
  var r = [], n = [];
  return t.forEach(function(o, s) {
    var i = !!o.scopeParent, c = i ? o.scopeParent : o, a = Yt(c, i), l = i ? e(o.candidates) : c;
    a === 0 ? i ? r.push.apply(r, l) : r.push(c) : n.push({
      documentOrder: s,
      tabIndex: a,
      item: o,
      isScope: i,
      content: l
    });
  }), n.sort(Ut).reduce(function(o, s) {
    return s.isScope ? o.push.apply(o, s.content) : o.push(s.content), o;
  }, []).concat(r);
}, gt = function(t, r) {
  r = r || {};
  var n;
  return r.getShadowRoot ? n = jt([t], r.includeContainer, {
    filter: $e.bind(null, r),
    flatten: !1,
    getShadowRoot: r.getShadowRoot,
    shadowRootFilter: rn
  }) : n = Kt(t, r.includeContainer, $e.bind(null, r)), on(n);
};
function _e(e, t, r) {
  let {
    reference: n,
    floating: o
  } = e;
  const s = ke(t), i = Wt(t), c = Bt(i), a = Ne(t), l = s === "y", u = n.x + n.width / 2 - o.width / 2, d = n.y + n.height / 2 - o.height / 2, m = n[c] / 2 - o[c] / 2;
  let g;
  switch (a) {
    case "top":
      g = {
        x: u,
        y: n.y - o.height
      };
      break;
    case "bottom":
      g = {
        x: u,
        y: n.y + n.height
      };
      break;
    case "right":
      g = {
        x: n.x + n.width,
        y: d
      };
      break;
    case "left":
      g = {
        x: n.x - o.width,
        y: d
      };
      break;
    default:
      g = {
        x: n.x,
        y: n.y
      };
  }
  switch (lt(t)) {
    case "start":
      g[i] -= m * (r && l ? -1 : 1);
      break;
    case "end":
      g[i] += m * (r && l ? -1 : 1);
      break;
  }
  return g;
}
const sn = async (e, t, r) => {
  const {
    placement: n = "bottom",
    strategy: o = "absolute",
    middleware: s = [],
    platform: i
  } = r, c = s.filter(Boolean), a = await (i.isRTL == null ? void 0 : i.isRTL(t));
  let l = await i.getElementRects({
    reference: e,
    floating: t,
    strategy: o
  }), {
    x: u,
    y: d
  } = _e(l, n, a), m = n, g = {}, h = 0;
  for (let p = 0; p < c.length; p++) {
    const {
      name: v,
      fn: w
    } = c[p], {
      x: C,
      y,
      data: R,
      reset: S
    } = await w({
      x: u,
      y: d,
      initialPlacement: n,
      placement: m,
      strategy: o,
      middlewareData: g,
      rects: l,
      platform: i,
      elements: {
        reference: e,
        floating: t
      }
    });
    u = C ?? u, d = y ?? d, g = {
      ...g,
      [v]: {
        ...g[v],
        ...R
      }
    }, S && h <= 50 && (h++, typeof S == "object" && (S.placement && (m = S.placement), S.rects && (l = S.rects === !0 ? await i.getElementRects({
      reference: e,
      floating: t,
      strategy: o
    }) : S.rects), {
      x: u,
      y: d
    } = _e(l, m, a)), p = -1);
  }
  return {
    x: u,
    y: d,
    placement: m,
    strategy: o,
    middlewareData: g
  };
};
async function cn(e, t) {
  var r;
  t === void 0 && (t = {});
  const {
    x: n,
    y: o,
    platform: s,
    rects: i,
    elements: c,
    strategy: a
  } = e, {
    boundary: l = "clippingAncestors",
    rootBoundary: u = "viewport",
    elementContext: d = "floating",
    altBoundary: m = !1,
    padding: g = 0
  } = ct(t, e), h = _t(g), v = c[m ? d === "floating" ? "reference" : "floating" : d], w = ae(await s.getClippingRect({
    element: (r = await (s.isElement == null ? void 0 : s.isElement(v))) == null || r ? v : v.contextElement || await (s.getDocumentElement == null ? void 0 : s.getDocumentElement(c.floating)),
    boundary: l,
    rootBoundary: u,
    strategy: a
  })), C = d === "floating" ? {
    x: n,
    y: o,
    width: i.floating.width,
    height: i.floating.height
  } : i.reference, y = await (s.getOffsetParent == null ? void 0 : s.getOffsetParent(c.floating)), R = await (s.isElement == null ? void 0 : s.isElement(y)) ? await (s.getScale == null ? void 0 : s.getScale(y)) || {
    x: 1,
    y: 1
  } : {
    x: 1,
    y: 1
  }, S = ae(s.convertOffsetParentRelativeRectToViewportRelativeRect ? await s.convertOffsetParentRelativeRectToViewportRelativeRect({
    elements: c,
    rect: C,
    offsetParent: y,
    strategy: a
  }) : C);
  return {
    top: (w.top - S.top + h.top) / R.y,
    bottom: (S.bottom - w.bottom + h.bottom) / R.y,
    left: (w.left - S.left + h.left) / R.x,
    right: (S.right - w.right + h.right) / R.x
  };
}
const ln = function(e) {
  return e === void 0 && (e = {}), {
    name: "size",
    options: e,
    async fn(t) {
      var r, n;
      const {
        placement: o,
        rects: s,
        platform: i,
        elements: c
      } = t, {
        apply: a = () => {
        },
        ...l
      } = ct(e, t), u = await cn(t, l), d = Ne(o), m = lt(o), g = ke(o) === "y", {
        width: h,
        height: p
      } = s.floating;
      let v, w;
      d === "top" || d === "bottom" ? (v = d, w = m === (await (i.isRTL == null ? void 0 : i.isRTL(c.floating)) ? "start" : "end") ? "left" : "right") : (w = d, v = m === "end" ? "top" : "bottom");
      const C = p - u.top - u.bottom, y = h - u.left - u.right, R = ce(p - u[v], C), S = ce(h - u[w], y), A = !t.middlewareData.shift;
      let I = R, P = S;
      if ((r = t.middlewareData.shift) != null && r.enabled.x && (P = y), (n = t.middlewareData.shift) != null && n.enabled.y && (I = C), A && !m) {
        const W = $(u.left, 0), _ = $(u.right, 0), Y = $(u.top, 0), M = $(u.bottom, 0);
        g ? P = h - 2 * (W !== 0 || _ !== 0 ? W + _ : $(u.left, u.right)) : I = p - 2 * (Y !== 0 || M !== 0 ? Y + M : $(u.top, u.bottom));
      }
      await a({
        ...t,
        availableWidth: P,
        availableHeight: I
      });
      const j = await i.getDimensions(c.floating);
      return h !== j.width || p !== j.height ? {
        reset: {
          rects: !0
        }
      } : {};
    }
  };
};
function ht(e) {
  const t = B(e);
  let r = parseFloat(t.width) || 0, n = parseFloat(t.height) || 0;
  const o = k(e), s = o ? e.offsetWidth : r, i = o ? e.offsetHeight : n, c = le(r) !== s || le(n) !== i;
  return c && (r = s, n = i), {
    width: r,
    height: n,
    $: c
  };
}
function pt(e) {
  return T(e) ? e : e.contextElement;
}
function J(e) {
  const t = pt(e);
  if (!k(t))
    return q(1);
  const r = t.getBoundingClientRect(), {
    width: n,
    height: o,
    $: s
  } = ht(t);
  let i = (s ? le(r.width) : r.width) / n, c = (s ? le(r.height) : r.height) / o;
  return (!i || !Number.isFinite(i)) && (i = 1), (!c || !Number.isFinite(c)) && (c = 1), {
    x: i,
    y: c
  };
}
const an = /* @__PURE__ */ q(0);
function mt(e) {
  const t = N(e);
  return !Ae() || !t.visualViewport ? an : {
    x: t.visualViewport.offsetLeft,
    y: t.visualViewport.offsetTop
  };
}
function un(e, t, r) {
  return t === void 0 && (t = !1), !r || t && r !== N(e) ? !1 : t;
}
function oe(e, t, r, n) {
  t === void 0 && (t = !1), r === void 0 && (r = !1);
  const o = e.getBoundingClientRect(), s = pt(e);
  let i = q(1);
  t && (n ? T(n) && (i = J(n)) : i = J(e));
  const c = un(s, r, n) ? mt(s) : q(0);
  let a = (o.left + c.x) / i.x, l = (o.top + c.y) / i.y, u = o.width / i.x, d = o.height / i.y;
  if (s) {
    const m = N(s), g = n && T(n) ? N(n) : n;
    let h = m, p = Ee(h);
    for (; p && n && g !== h; ) {
      const v = J(p), w = p.getBoundingClientRect(), C = B(p), y = w.left + (p.clientLeft + parseFloat(C.paddingLeft)) * v.x, R = w.top + (p.clientTop + parseFloat(C.paddingTop)) * v.y;
      a *= v.x, l *= v.y, u *= v.x, d *= v.y, a += y, l += R, h = N(p), p = Ee(h);
    }
  }
  return ae({
    width: u,
    height: d,
    x: a,
    y: l
  });
}
function fn(e) {
  let {
    elements: t,
    rect: r,
    offsetParent: n,
    strategy: o
  } = e;
  const s = o === "fixed", i = K(n), c = t ? he(t.floating) : !1;
  if (n === i || c && s)
    return r;
  let a = {
    scrollLeft: 0,
    scrollTop: 0
  }, l = q(1);
  const u = q(0), d = k(n);
  if ((d || !d && !s) && ((Q(n) !== "body" || ie(i)) && (a = pe(n)), k(n))) {
    const m = oe(n);
    l = J(n), u.x = m.x + n.clientLeft, u.y = m.y + n.clientTop;
  }
  return {
    width: r.width * l.x,
    height: r.height * l.y,
    x: r.x * l.x - a.scrollLeft * l.x + u.x,
    y: r.y * l.y - a.scrollTop * l.y + u.y
  };
}
function dn(e) {
  return Array.from(e.getClientRects());
}
function Oe(e, t) {
  const r = pe(e).scrollLeft;
  return t ? t.left + r : oe(K(e)).left + r;
}
function gn(e) {
  const t = K(e), r = pe(e), n = e.ownerDocument.body, o = $(t.scrollWidth, t.clientWidth, n.scrollWidth, n.clientWidth), s = $(t.scrollHeight, t.clientHeight, n.scrollHeight, n.clientHeight);
  let i = -r.scrollLeft + Oe(e);
  const c = -r.scrollTop;
  return B(n).direction === "rtl" && (i += $(t.clientWidth, n.clientWidth) - o), {
    width: o,
    height: s,
    x: i,
    y: c
  };
}
function hn(e, t) {
  const r = N(e), n = K(e), o = r.visualViewport;
  let s = n.clientWidth, i = n.clientHeight, c = 0, a = 0;
  if (o) {
    s = o.width, i = o.height;
    const l = Ae();
    (!l || l && t === "fixed") && (c = o.offsetLeft, a = o.offsetTop);
  }
  return {
    width: s,
    height: i,
    x: c,
    y: a
  };
}
function pn(e, t) {
  const r = oe(e, !0, t === "fixed"), n = r.top + e.clientTop, o = r.left + e.clientLeft, s = k(e) ? J(e) : q(1), i = e.clientWidth * s.x, c = e.clientHeight * s.y, a = o * s.x, l = n * s.y;
  return {
    width: i,
    height: c,
    x: a,
    y: l
  };
}
function Ve(e, t, r) {
  let n;
  if (t === "viewport")
    n = hn(e, r);
  else if (t === "document")
    n = gn(K(e));
  else if (T(t))
    n = pn(t, r);
  else {
    const o = mt(e);
    n = {
      ...t,
      x: t.x - o.x,
      y: t.y - o.y
    };
  }
  return ae(n);
}
function vt(e, t) {
  const r = H(e);
  return r === t || !T(r) || X(r) ? !1 : B(r).position === "fixed" || vt(r, t);
}
function mn(e, t) {
  const r = t.get(e);
  if (r)
    return r;
  let n = Z(e, [], !1).filter((c) => T(c) && Q(c) !== "body"), o = null;
  const s = B(e).position === "fixed";
  let i = s ? H(e) : e;
  for (; T(i) && !X(i); ) {
    const c = B(i), a = Ie(i);
    !a && c.position === "fixed" && (o = null), (s ? !a && !o : !a && c.position === "static" && !!o && ["absolute", "fixed"].includes(o.position) || ie(i) && !a && vt(e, i)) ? n = n.filter((u) => u !== i) : o = c, i = H(i);
  }
  return t.set(e, n), n;
}
function vn(e) {
  let {
    element: t,
    boundary: r,
    rootBoundary: n,
    strategy: o
  } = e;
  const i = [...r === "clippingAncestors" ? he(t) ? [] : mn(t, this._c) : [].concat(r), n], c = i[0], a = i.reduce((l, u) => {
    const d = Ve(t, u, o);
    return l.top = $(d.top, l.top), l.right = ce(d.right, l.right), l.bottom = ce(d.bottom, l.bottom), l.left = $(d.left, l.left), l;
  }, Ve(t, c, o));
  return {
    width: a.right - a.left,
    height: a.bottom - a.top,
    x: a.left,
    y: a.top
  };
}
function bn(e) {
  const {
    width: t,
    height: r
  } = ht(e);
  return {
    width: t,
    height: r
  };
}
function yn(e, t, r) {
  const n = k(t), o = K(t), s = r === "fixed", i = oe(e, !0, s, t);
  let c = {
    scrollLeft: 0,
    scrollTop: 0
  };
  const a = q(0);
  if (n || !n && !s)
    if ((Q(t) !== "body" || ie(o)) && (c = pe(t)), n) {
      const g = oe(t, !0, s, t);
      a.x = g.x + t.clientLeft, a.y = g.y + t.clientTop;
    } else o && (a.x = Oe(o));
  let l = 0, u = 0;
  if (o && !n && !s) {
    const g = o.getBoundingClientRect();
    u = g.top + c.scrollTop, l = g.left + c.scrollLeft - // RTL <body> scrollbar.
    Oe(o, g);
  }
  const d = i.left + c.scrollLeft - a.x - l, m = i.top + c.scrollTop - a.y - u;
  return {
    x: d,
    y: m,
    width: i.width,
    height: i.height
  };
}
function ve(e) {
  return B(e).position === "static";
}
function He(e, t) {
  if (!k(e) || B(e).position === "fixed")
    return null;
  if (t)
    return t(e);
  let r = e.offsetParent;
  return K(e) === r && (r = r.ownerDocument.body), r;
}
function bt(e, t) {
  const r = N(e);
  if (he(e))
    return r;
  if (!k(e)) {
    let o = H(e);
    for (; o && !X(o); ) {
      if (T(o) && !ve(o))
        return o;
      o = H(o);
    }
    return r;
  }
  let n = He(e, t);
  for (; n && Dt(n) && ve(n); )
    n = He(n, t);
  return n && X(n) && ve(n) && !Ie(n) ? r : n || Pt(e) || r;
}
const wn = async function(e) {
  const t = this.getOffsetParent || bt, r = this.getDimensions, n = await r(e.floating);
  return {
    reference: yn(e.reference, await t(e.floating), e.strategy),
    floating: {
      x: 0,
      y: 0,
      width: n.width,
      height: n.height
    }
  };
};
function xn(e) {
  return B(e).direction === "rtl";
}
const Rn = {
  convertOffsetParentRelativeRectToViewportRelativeRect: fn,
  getDocumentElement: K,
  getClippingRect: vn,
  getOffsetParent: bt,
  getElementRects: wn,
  getClientRects: dn,
  getDimensions: bn,
  getScale: J,
  isElement: T,
  isRTL: xn
}, En = ln, Cn = (e, t, r) => {
  const n = /* @__PURE__ */ new Map(), o = {
    platform: Rn,
    ...r
  }, s = {
    ...o.platform,
    _c: n
  };
  return sn(e, t, {
    ...o,
    platform: s
  });
};
var se = typeof document < "u" ? tt : nt;
function de(e, t) {
  if (e === t)
    return !0;
  if (typeof e != typeof t)
    return !1;
  if (typeof e == "function" && e.toString() === t.toString())
    return !0;
  let r, n, o;
  if (e && t && typeof e == "object") {
    if (Array.isArray(e)) {
      if (r = e.length, r !== t.length) return !1;
      for (n = r; n-- !== 0; )
        if (!de(e[n], t[n]))
          return !1;
      return !0;
    }
    if (o = Object.keys(e), r = o.length, r !== Object.keys(t).length)
      return !1;
    for (n = r; n-- !== 0; )
      if (!{}.hasOwnProperty.call(t, o[n]))
        return !1;
    for (n = r; n-- !== 0; ) {
      const s = o[n];
      if (!(s === "_owner" && e.$$typeof) && !de(e[s], t[s]))
        return !1;
    }
    return !0;
  }
  return e !== e && t !== t;
}
function yt(e) {
  return typeof window > "u" ? 1 : (e.ownerDocument.defaultView || window).devicePixelRatio || 1;
}
function Ke(e, t) {
  const r = yt(e);
  return Math.round(t * r) / r;
}
function be(e) {
  const t = f.useRef(e);
  return se(() => {
    t.current = e;
  }), t;
}
function Sn(e) {
  e === void 0 && (e = {});
  const {
    placement: t = "bottom",
    strategy: r = "absolute",
    middleware: n = [],
    platform: o,
    elements: {
      reference: s,
      floating: i
    } = {},
    transform: c = !0,
    whileElementsMounted: a,
    open: l
  } = e, [u, d] = f.useState({
    x: 0,
    y: 0,
    strategy: r,
    placement: t,
    middlewareData: {},
    isPositioned: !1
  }), [m, g] = f.useState(n);
  de(m, n) || g(n);
  const [h, p] = f.useState(null), [v, w] = f.useState(null), C = f.useCallback((b) => {
    b !== A.current && (A.current = b, p(b));
  }, []), y = f.useCallback((b) => {
    b !== I.current && (I.current = b, w(b));
  }, []), R = s || h, S = i || v, A = f.useRef(null), I = f.useRef(null), P = f.useRef(u), j = a != null, W = be(a), _ = be(o), Y = be(l), M = f.useCallback(() => {
    if (!A.current || !I.current)
      return;
    const b = {
      placement: t,
      strategy: r,
      middleware: m
    };
    _.current && (b.platform = _.current), Cn(A.current, I.current, b).then((V) => {
      const L = {
        ...V,
        // The floating element's position may be recomputed while it's closed
        // but still mounted (such as when transitioning out). To ensure
        // `isPositioned` will be `false` initially on the next open, avoid
        // setting it to `true` when `open === false` (must be specified).
        isPositioned: Y.current !== !1
      };
      x.current && !de(P.current, L) && (P.current = L, rt.flushSync(() => {
        d(L);
      }));
    });
  }, [m, t, r, _, Y]);
  se(() => {
    l === !1 && P.current.isPositioned && (P.current.isPositioned = !1, d((b) => ({
      ...b,
      isPositioned: !1
    })));
  }, [l]);
  const x = f.useRef(!1);
  se(() => (x.current = !0, () => {
    x.current = !1;
  }), []), se(() => {
    if (R && (A.current = R), S && (I.current = S), R && S) {
      if (W.current)
        return W.current(R, S, M);
      M();
    }
  }, [R, S, M, W, j]);
  const D = f.useMemo(() => ({
    reference: A,
    floating: I,
    setReference: C,
    setFloating: y
  }), [C, y]), E = f.useMemo(() => ({
    reference: R,
    floating: S
  }), [R, S]), O = f.useMemo(() => {
    const b = {
      position: r,
      left: 0,
      top: 0
    };
    if (!E.floating)
      return b;
    const V = Ke(E.floating, u.x), L = Ke(E.floating, u.y);
    return c ? {
      ...b,
      transform: "translate(" + V + "px, " + L + "px)",
      ...yt(E.floating) >= 1.5 && {
        willChange: "transform"
      }
    } : {
      position: r,
      left: V,
      top: L
    };
  }, [r, c, E.floating, u.x, u.y]);
  return f.useMemo(() => ({
    ...u,
    update: M,
    refs: D,
    elements: E,
    floatingStyles: O
  }), [u, M, D, E, O]);
}
const Gn = (e, t) => ({
  ...En(e),
  options: [e, t]
}), wt = {
  ...f
}, Tn = wt.useInsertionEffect, On = Tn || ((e) => e());
function z(e) {
  const t = f.useRef(() => {
    if (process.env.NODE_ENV !== "production")
      throw new Error("Cannot call an event handler while rendering.");
  });
  return On(() => {
    t.current = e;
  }), f.useCallback(function() {
    for (var r = arguments.length, n = new Array(r), o = 0; o < r; o++)
      n[o] = arguments[o];
    return t.current == null ? void 0 : t.current(...n);
  }, []);
}
var G = typeof document < "u" ? tt : nt;
function De() {
  return De = Object.assign ? Object.assign.bind() : function(e) {
    for (var t = 1; t < arguments.length; t++) {
      var r = arguments[t];
      for (var n in r)
        Object.prototype.hasOwnProperty.call(r, n) && (e[n] = r[n]);
    }
    return e;
  }, De.apply(this, arguments);
}
let je = !1, Dn = 0;
const Ye = () => (
  // Ensure the id is unique with multiple independent versions of Floating UI
  // on <React 18
  "floating-ui-" + Math.random().toString(36).slice(2, 6) + Dn++
);
function Pn() {
  const [e, t] = f.useState(() => je ? Ye() : void 0);
  return G(() => {
    e == null && t(Ye());
  }, []), f.useEffect(() => {
    je = !0;
  }, []), e;
}
const In = wt.useId, xt = In || Pn;
let Pe;
process.env.NODE_ENV !== "production" && (Pe = /* @__PURE__ */ new Set());
function An() {
  for (var e, t = arguments.length, r = new Array(t), n = 0; n < t; n++)
    r[n] = arguments[n];
  const o = "Floating UI: " + r.join(" ");
  if (!((e = Pe) != null && e.has(o))) {
    var s;
    (s = Pe) == null || s.add(o), console.error(o);
  }
}
function Nn() {
  const e = /* @__PURE__ */ new Map();
  return {
    emit(t, r) {
      var n;
      (n = e.get(t)) == null || n.forEach((o) => o(r));
    },
    on(t, r) {
      e.set(t, [...e.get(t) || [], r]);
    },
    off(t, r) {
      var n;
      e.set(t, ((n = e.get(t)) == null ? void 0 : n.filter((o) => o !== r)) || []);
    }
  };
}
const kn = /* @__PURE__ */ f.createContext(null), Mn = /* @__PURE__ */ f.createContext(null), Ln = () => {
  var e;
  return ((e = f.useContext(kn)) == null ? void 0 : e.id) || null;
}, Rt = () => f.useContext(Mn);
function Me(e) {
  return "data-floating-ui-" + e;
}
function ye(e, t) {
  let r = e.filter((o) => {
    var s;
    return o.parentId === t && ((s = o.context) == null ? void 0 : s.open);
  }), n = r;
  for (; n.length; )
    n = e.filter((o) => {
      var s;
      return (s = n) == null ? void 0 : s.some((i) => {
        var c;
        return o.parentId === i.id && ((c = o.context) == null ? void 0 : c.open);
      });
    }), r = r.concat(n);
  return r;
}
const Et = () => ({
  getShadowRoot: !0,
  displayCheck: (
    // JSDOM does not support the `tabbable` library. To solve this we can
    // check if `ResizeObserver` is a real function (not polyfilled), which
    // determines if the current environment is JSDOM-like.
    typeof ResizeObserver == "function" && ResizeObserver.toString().includes("[native code]") ? "full" : "none"
  )
});
function Ct(e, t) {
  const r = gt(e, Et());
  t === "prev" && r.reverse();
  const n = r.indexOf(It(Se(e)));
  return r.slice(n + 1)[0];
}
function Fn() {
  return Ct(document.body, "next");
}
function Bn() {
  return Ct(document.body, "prev");
}
function we(e, t) {
  const r = t || e.currentTarget, n = e.relatedTarget;
  return !n || !Ce(r, n);
}
function Wn(e) {
  gt(e, Et()).forEach((r) => {
    r.dataset.tabindex = r.getAttribute("tabindex") || "", r.setAttribute("tabindex", "-1");
  });
}
function Ue(e) {
  e.querySelectorAll("[data-tabindex]").forEach((r) => {
    const n = r.dataset.tabindex;
    delete r.dataset.tabindex, n ? r.setAttribute("tabindex", n) : r.removeAttribute("tabindex");
  });
}
const St = {
  border: 0,
  clip: "rect(0 0 0 0)",
  height: "1px",
  margin: "-1px",
  overflow: "hidden",
  padding: 0,
  position: "fixed",
  whiteSpace: "nowrap",
  width: "1px",
  top: 0,
  left: 0
};
let $n;
function Xe(e) {
  e.key === "Tab" && (e.target, clearTimeout($n));
}
const qe = /* @__PURE__ */ f.forwardRef(function(t, r) {
  const [n, o] = f.useState();
  G(() => (At() && o("button"), document.addEventListener("keydown", Xe), () => {
    document.removeEventListener("keydown", Xe);
  }), []);
  const s = {
    ref: r,
    tabIndex: 0,
    // Role is only for VoiceOver
    role: n,
    "aria-hidden": n ? void 0 : !0,
    [Me("focus-guard")]: "",
    style: St
  };
  return /* @__PURE__ */ f.createElement("span", De({}, t, s));
}), Tt = /* @__PURE__ */ f.createContext(null), Ge = /* @__PURE__ */ Me("portal");
function _n(e) {
  e === void 0 && (e = {});
  const {
    id: t,
    root: r
  } = e, n = xt(), o = Vn(), [s, i] = f.useState(null), c = f.useRef(null);
  return G(() => () => {
    s == null || s.remove(), queueMicrotask(() => {
      c.current = null;
    });
  }, [s]), G(() => {
    if (!n || c.current) return;
    const a = t ? document.getElementById(t) : null;
    if (!a) return;
    const l = document.createElement("div");
    l.id = n, l.setAttribute(Ge, ""), a.appendChild(l), c.current = l, i(l);
  }, [t, n]), G(() => {
    if (!n || c.current) return;
    let a = r || (o == null ? void 0 : o.portalNode);
    a && !T(a) && (a = a.current), a = a || document.body;
    let l = null;
    t && (l = document.createElement("div"), l.id = t, a.appendChild(l));
    const u = document.createElement("div");
    u.id = n, u.setAttribute(Ge, ""), a = l || a, a.appendChild(u), c.current = u, i(u);
  }, [t, r, n, o]), s;
}
function zn(e) {
  const {
    children: t,
    id: r,
    root: n = null,
    preserveTabOrder: o = !0
  } = e, s = _n({
    id: r,
    root: n
  }), [i, c] = f.useState(null), a = f.useRef(null), l = f.useRef(null), u = f.useRef(null), d = f.useRef(null), m = i == null ? void 0 : i.modal, g = i == null ? void 0 : i.open, h = (
    // The FocusManager and therefore floating element are currently open/
    // rendered.
    !!i && // Guards are only for non-modal focus management.
    !i.modal && // Don't render if unmount is transitioning.
    i.open && o && !!(n || s)
  );
  return f.useEffect(() => {
    if (!s || !o || m)
      return;
    function p(v) {
      s && we(v) && (v.type === "focusin" ? Ue : Wn)(s);
    }
    return s.addEventListener("focusin", p, !0), s.addEventListener("focusout", p, !0), () => {
      s.removeEventListener("focusin", p, !0), s.removeEventListener("focusout", p, !0);
    };
  }, [s, o, m]), f.useEffect(() => {
    s && (g || Ue(s));
  }, [g, s]), /* @__PURE__ */ f.createElement(Tt.Provider, {
    value: f.useMemo(() => ({
      preserveTabOrder: o,
      beforeOutsideRef: a,
      afterOutsideRef: l,
      beforeInsideRef: u,
      afterInsideRef: d,
      portalNode: s,
      setFocusManagerState: c
    }), [o, s])
  }, h && s && /* @__PURE__ */ f.createElement(qe, {
    "data-type": "outside",
    ref: a,
    onFocus: (p) => {
      if (we(p, s)) {
        var v;
        (v = u.current) == null || v.focus();
      } else {
        const w = Bn() || (i == null ? void 0 : i.refs.domReference.current);
        w == null || w.focus();
      }
    }
  }), h && s && /* @__PURE__ */ f.createElement("span", {
    "aria-owns": s.id,
    style: St
  }), s && /* @__PURE__ */ rt.createPortal(t, s), h && s && /* @__PURE__ */ f.createElement(qe, {
    "data-type": "outside",
    ref: l,
    onFocus: (p) => {
      if (we(p, s)) {
        var v;
        (v = d.current) == null || v.focus();
      } else {
        const w = Fn() || (i == null ? void 0 : i.refs.domReference.current);
        w == null || w.focus(), i != null && i.closeOnFocusOut && (i == null || i.onOpenChange(!1, p.nativeEvent, "focus-out"));
      }
    }
  }));
}
const Vn = () => f.useContext(Tt), Hn = "data-floating-ui-focusable";
function ze(e) {
  return k(e.target) && e.target.tagName === "BUTTON";
}
function Ze(e) {
  return Lt(e);
}
function Zn(e, t) {
  t === void 0 && (t = {});
  const {
    open: r,
    onOpenChange: n,
    dataRef: o,
    elements: {
      domReference: s
    }
  } = e, {
    enabled: i = !0,
    event: c = "click",
    toggle: a = !0,
    ignoreMouse: l = !1,
    keyboardHandlers: u = !0
  } = t, d = f.useRef(), m = f.useRef(!1), g = f.useMemo(() => ({
    onPointerDown(h) {
      d.current = h.pointerType;
    },
    onMouseDown(h) {
      const p = d.current;
      h.button === 0 && c !== "click" && (Be(p) && l || (r && a && (!o.current.openEvent || o.current.openEvent.type === "mousedown") ? n(!1, h.nativeEvent, "click") : (h.preventDefault(), n(!0, h.nativeEvent, "click"))));
    },
    onClick(h) {
      const p = d.current;
      if (c === "mousedown" && d.current) {
        d.current = void 0;
        return;
      }
      Be(p) && l || (r && a && (!o.current.openEvent || o.current.openEvent.type === "click") ? n(!1, h.nativeEvent, "click") : n(!0, h.nativeEvent, "click"));
    },
    onKeyDown(h) {
      d.current = void 0, !(h.defaultPrevented || !u || ze(h)) && (h.key === " " && !Ze(s) && (h.preventDefault(), m.current = !0), h.key === "Enter" && n(!(r && a), h.nativeEvent, "click"));
    },
    onKeyUp(h) {
      h.defaultPrevented || !u || ze(h) || Ze(s) || h.key === " " && m.current && (m.current = !1, n(!(r && a), h.nativeEvent, "click"));
    }
  }), [o, s, c, l, u, n, r, a]);
  return f.useMemo(() => i ? {
    reference: g
  } : {}, [i, g]);
}
const Kn = {
  pointerdown: "onPointerDown",
  mousedown: "onMouseDown",
  click: "onClick"
}, jn = {
  pointerdown: "onPointerDownCapture",
  mousedown: "onMouseDownCapture",
  click: "onClickCapture"
}, Je = (e) => {
  var t, r;
  return {
    escapeKey: typeof e == "boolean" ? e : (t = e == null ? void 0 : e.escapeKey) != null ? t : !1,
    outsidePress: typeof e == "boolean" ? e : (r = e == null ? void 0 : e.outsidePress) != null ? r : !0
  };
};
function Jn(e, t) {
  t === void 0 && (t = {});
  const {
    open: r,
    onOpenChange: n,
    elements: o,
    dataRef: s
  } = e, {
    enabled: i = !0,
    escapeKey: c = !0,
    outsidePress: a = !0,
    outsidePressEvent: l = "pointerdown",
    referencePress: u = !1,
    referencePressEvent: d = "pointerdown",
    ancestorScroll: m = !1,
    bubbles: g,
    capture: h
  } = t, p = Rt(), v = z(typeof a == "function" ? a : () => !1), w = typeof a == "function" ? v : a, C = f.useRef(!1), y = f.useRef(!1), {
    escapeKey: R,
    outsidePress: S
  } = Je(g), {
    escapeKey: A,
    outsidePress: I
  } = Je(h), P = z((x) => {
    var D;
    if (!r || !i || !c || x.key !== "Escape")
      return;
    const E = (D = s.current.floatingContext) == null ? void 0 : D.nodeId, O = p ? ye(p.nodesRef.current, E) : [];
    if (!R && (x.stopPropagation(), O.length > 0)) {
      let b = !0;
      if (O.forEach((V) => {
        var L;
        if ((L = V.context) != null && L.open && !V.context.dataRef.current.__escapeKeyBubbles) {
          b = !1;
          return;
        }
      }), !b)
        return;
    }
    n(!1, Nt(x) ? x.nativeEvent : x, "escape-key");
  }), j = z((x) => {
    var D;
    const E = () => {
      var O;
      P(x), (O = ne(x)) == null || O.removeEventListener("keydown", E);
    };
    (D = ne(x)) == null || D.addEventListener("keydown", E);
  }), W = z((x) => {
    var D;
    const E = C.current;
    C.current = !1;
    const O = y.current;
    if (y.current = !1, l === "click" && O || E || typeof w == "function" && !w(x))
      return;
    const b = ne(x), V = "[" + Me("inert") + "]", L = Se(o.floating).querySelectorAll(V);
    let ee = T(b) ? b : null;
    for (; ee && !X(ee); ) {
      const F = H(ee);
      if (X(F) || !T(F))
        break;
      ee = F;
    }
    if (L.length && T(b) && !kt(b) && // Clicked on a direct ancestor (e.g. FloatingOverlay).
    !Ce(b, o.floating) && // If the target root element contains none of the markers, then the
    // element was injected after the floating element rendered.
    Array.from(L).every((F) => !Ce(ee, F)))
      return;
    if (k(b) && M) {
      const F = b.clientWidth > 0 && b.scrollWidth > b.clientWidth, U = b.clientHeight > 0 && b.scrollHeight > b.clientHeight;
      let te = U && x.offsetX > b.clientWidth;
      if (U && B(b).direction === "rtl" && (te = x.offsetX <= b.offsetWidth - b.clientWidth), te || F && x.offsetY > b.clientHeight)
        return;
    }
    const Le = (D = s.current.floatingContext) == null ? void 0 : D.nodeId, Ot = p && ye(p.nodesRef.current, Le).some((F) => {
      var U;
      return me(x, (U = F.context) == null ? void 0 : U.elements.floating);
    });
    if (me(x, o.floating) || me(x, o.domReference) || Ot)
      return;
    const Fe = p ? ye(p.nodesRef.current, Le) : [];
    if (Fe.length > 0) {
      let F = !0;
      if (Fe.forEach((U) => {
        var te;
        if ((te = U.context) != null && te.open && !U.context.dataRef.current.__outsidePressBubbles) {
          F = !1;
          return;
        }
      }), !F)
        return;
    }
    n(!1, x, "outside-press");
  }), _ = z((x) => {
    var D;
    const E = () => {
      var O;
      W(x), (O = ne(x)) == null || O.removeEventListener(l, E);
    };
    (D = ne(x)) == null || D.addEventListener(l, E);
  });
  f.useEffect(() => {
    if (!r || !i)
      return;
    s.current.__escapeKeyBubbles = R, s.current.__outsidePressBubbles = S;
    function x(O) {
      n(!1, O, "ancestor-scroll");
    }
    const D = Se(o.floating);
    c && D.addEventListener("keydown", A ? j : P, A), w && D.addEventListener(l, I ? _ : W, I);
    let E = [];
    return m && (T(o.domReference) && (E = Z(o.domReference)), T(o.floating) && (E = E.concat(Z(o.floating))), !T(o.reference) && o.reference && o.reference.contextElement && (E = E.concat(Z(o.reference.contextElement)))), E = E.filter((O) => {
      var b;
      return O !== ((b = D.defaultView) == null ? void 0 : b.visualViewport);
    }), E.forEach((O) => {
      O.addEventListener("scroll", x, {
        passive: !0
      });
    }), () => {
      c && D.removeEventListener("keydown", A ? j : P, A), w && D.removeEventListener(l, I ? _ : W, I), E.forEach((O) => {
        O.removeEventListener("scroll", x);
      });
    };
  }, [s, o, c, w, l, r, n, m, i, R, S, P, A, j, W, I, _]), f.useEffect(() => {
    C.current = !1;
  }, [w, l]);
  const Y = f.useMemo(() => ({
    onKeyDown: P,
    [Kn[d]]: (x) => {
      u && n(!1, x.nativeEvent, "reference-press");
    }
  }), [P, n, u, d]), M = f.useMemo(() => ({
    onKeyDown: P,
    onMouseDown() {
      y.current = !0;
    },
    onMouseUp() {
      y.current = !0;
    },
    [jn[l]]: () => {
      C.current = !0;
    }
  }), [P, l]);
  return f.useMemo(() => i ? {
    reference: Y,
    floating: M
  } : {}, [i, Y, M]);
}
function Yn(e) {
  const {
    open: t = !1,
    onOpenChange: r,
    elements: n
  } = e, o = xt(), s = f.useRef({}), [i] = f.useState(() => Nn()), c = Ln() != null;
  if (process.env.NODE_ENV !== "production") {
    const g = n.reference;
    g && !T(g) && An("Cannot pass a virtual element to the `elements.reference` option,", "as it must be a real DOM element. Use `refs.setPositionReference()`", "instead.");
  }
  const [a, l] = f.useState(n.reference), u = z((g, h, p) => {
    s.current.openEvent = g ? h : void 0, i.emit("openchange", {
      open: g,
      event: h,
      reason: p,
      nested: c
    }), r == null || r(g, h, p);
  }), d = f.useMemo(() => ({
    setPositionReference: l
  }), []), m = f.useMemo(() => ({
    reference: a || n.reference || null,
    floating: n.floating || null,
    domReference: n.reference
  }), [a, n.reference, n.floating]);
  return f.useMemo(() => ({
    dataRef: s,
    open: t,
    onOpenChange: u,
    elements: m,
    events: i,
    floatingId: o,
    refs: d
  }), [t, u, m, i, o, d]);
}
function Qn(e) {
  e === void 0 && (e = {});
  const {
    nodeId: t
  } = e, r = Yn({
    ...e,
    elements: {
      reference: null,
      floating: null,
      ...e.elements
    }
  }), n = e.rootContext || r, o = n.elements, [s, i] = f.useState(null), [c, a] = f.useState(null), u = (o == null ? void 0 : o.reference) || s, d = f.useRef(null), m = Rt();
  G(() => {
    u && (d.current = u);
  }, [u]);
  const g = Sn({
    ...e,
    elements: {
      ...o,
      ...c && {
        reference: c
      }
    }
  }), h = f.useCallback((y) => {
    const R = T(y) ? {
      getBoundingClientRect: () => y.getBoundingClientRect(),
      contextElement: y
    } : y;
    a(R), g.refs.setReference(R);
  }, [g.refs]), p = f.useCallback((y) => {
    (T(y) || y === null) && (d.current = y, i(y)), (T(g.refs.reference.current) || g.refs.reference.current === null || // Don't allow setting virtual elements using the old technique back to
    // `null` to support `positionReference` + an unstable `reference`
    // callback ref.
    y !== null && !T(y)) && g.refs.setReference(y);
  }, [g.refs]), v = f.useMemo(() => ({
    ...g.refs,
    setReference: p,
    setPositionReference: h,
    domReference: d
  }), [g.refs, p, h]), w = f.useMemo(() => ({
    ...g.elements,
    domReference: u
  }), [g.elements, u]), C = f.useMemo(() => ({
    ...g,
    ...n,
    refs: v,
    elements: w,
    nodeId: t
  }), [g, v, w, t, n]);
  return G(() => {
    n.dataRef.current.floatingContext = C;
    const y = m == null ? void 0 : m.nodesRef.current.find((R) => R.id === t);
    y && (y.context = C);
  }), f.useMemo(() => ({
    ...g,
    context: C,
    refs: v,
    elements: w
  }), [g, v, w, C]);
}
const Qe = "active", et = "selected";
function xe(e, t, r) {
  const n = /* @__PURE__ */ new Map(), o = r === "item";
  let s = e;
  if (o && e) {
    const {
      [Qe]: i,
      [et]: c,
      ...a
    } = e;
    s = a;
  }
  return {
    ...r === "floating" && {
      tabIndex: -1,
      [Hn]: ""
    },
    ...s,
    ...t.map((i) => {
      const c = i ? i[r] : null;
      return typeof c == "function" ? e ? c(e) : null : c;
    }).concat(e).reduce((i, c) => (c && Object.entries(c).forEach((a) => {
      let [l, u] = a;
      if (!(o && [Qe, et].includes(l)))
        if (l.indexOf("on") === 0) {
          if (n.has(l) || n.set(l, []), typeof u == "function") {
            var d;
            (d = n.get(l)) == null || d.push(u), i[l] = function() {
              for (var m, g = arguments.length, h = new Array(g), p = 0; p < g; p++)
                h[p] = arguments[p];
              return (m = n.get(l)) == null ? void 0 : m.map((v) => v(...h)).find((v) => v !== void 0);
            };
          }
        } else
          i[l] = u;
    }), i), {})
  };
}
function er(e) {
  e === void 0 && (e = []);
  const t = e.map((c) => c == null ? void 0 : c.reference), r = e.map((c) => c == null ? void 0 : c.floating), n = e.map((c) => c == null ? void 0 : c.item), o = f.useCallback(
    (c) => xe(c, e, "reference"),
    // eslint-disable-next-line react-hooks/exhaustive-deps
    t
  ), s = f.useCallback(
    (c) => xe(c, e, "floating"),
    // eslint-disable-next-line react-hooks/exhaustive-deps
    r
  ), i = f.useCallback(
    (c) => xe(c, e, "item"),
    // eslint-disable-next-line react-hooks/exhaustive-deps
    n
  );
  return f.useMemo(() => ({
    getReferenceProps: o,
    getFloatingProps: s,
    getItemProps: i
  }), [o, s, i]);
}
export {
  zn as F,
  Zn as a,
  Jn as b,
  er as c,
  qn as d,
  Gn as s,
  Qn as u
};
